;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;  SELOR - Servidor de Emails Livre Orientado a Regras                             
;  Programado por Lucas Priori                                                     
;                                                                                  
;  Copyright (c) 2013,2014 Lucas Priori                                            
;                                                                                  
;  Permission is hereby granted, free of charge, to any person obtaining a copy    
;  of this software and associated documentation files (the "Software"), to deal   
;  in the Software without restriction, including without limitation the rights    
;  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell       
;  copies of the Software, and to permit persons to whom the Software is           
;  furnished to do so, subject to the following conditions:                        
;                                                                                  
;  The above copyright notice and this permission notice shall be included in      
;  all copies or substantial portions of the Software.                             
;                                                                                  
;  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      
;  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        
;  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     
;  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          
;  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   
;  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN       
;  THE SOFTWARE.                                                                   
;                                                                                  


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

[BITS 32]
;=======================================================================

%define TAM_str_itoa 32
%define DOSD_ip ebp
%define DOSD_timestamp ebp + 4
%define DOSD_mem ebp + 8
%define DOSD_fim_mem ebp + 12
%define DOSD_atual_posi ebp + 16
%define DOSD_intervalo ebp + 20
%define DOSD_num_ocorr ebp + 24
;---



global pular_carac
global str_arruma_crlf
global selor_strncpy
global special_cp
global selor_strncat
global selor_superstrncpy
global cmp_str
global cmp_str_vars
global base64_decod
global base64_cod
global selor_segcp
global t_inject_helo
global conv_crlf
global cpl
global itoa
global tmasc
global dosd
;-- Variaveis globais --
global base_val_email
global cpl_orig
global cpl_dest
global cpl_tambuffer
global cpl_tamlinha
global texto_itoa

;---
[SECTION .data]
                                ;   0 1 2 3 4 5 6 7 8 9 A B C D E F    
base_val_email			db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 0
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 1
				db  0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,0 ; 2
				db  1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0 ; 3
				db  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ; 4
				db  1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1 ; 5
				db  0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ; 6
				db  1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0 ; 7
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 8
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 9
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; A
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; B
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; C
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; D
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; E
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; F
;---
                                ;    0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F    
base64_reversa                  db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; 0
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; 1
				db  00,00,00,00,00,00,00,00,00,00,00,62,00,00,00,63 ; 2
				db  52,53,54,55,56,57,58,59,60,61,00,00,00,00,00,00 ; 3
				db  00,00,01,02,03,04,05,06,07,08,09,10,11,12,13,14 ; 4
				db  15,16,17,18,19,20,21,22,23,24,25,00,00,00,00,00 ; 5
				db  00,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40 ; 6
				db  41,42,43,44,45,46,47,48,49,50,51,00,00,00,00,00 ; 7
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; 8
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; 9
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; A
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; B
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; C
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; D
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; E
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; F
;---
base64_tab			db 'A','B','C','D','E','F','G','H','I','J','K','L','M',
				db 'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
				db 'a','b','c','d','e','f','g','h','i','j','k','l','m',
				db 'n','o','p','q','r','s','t','u','v','w','x','y','z',
				db '0','1','2','3','4','5','6','7','8','9','+','/', 0
;---
cpl_orig			dd  0
cpl_dest			dd  0
cpl_tambuffer			dd  0
cpl_tamlinha			dd  0
;---
texto_itoa			times TAM_str_itoa+1 db 0
;=======================================================================
[SECTION .text]

;======================================================= 
; Funcao para pular uma sequencia de caracteres          
; Retornos:                                              
; EAX -> Ponteiro da posicao do primeiro carac diferente 
; char *pular_carac(char *string, int carac)
pular_carac:			push esi
				mov  esi, [esp + 8]     ; string 
				mov  ah, [esp + 12]     ; carac  
.Volta:				lodsb
				cmp  al, ah
				je   .Volta
				dec  esi
				mov  eax, esi
				pop  esi
				ret
;======================================================= 
; Funcao para retirar o \r e converter o \n em ' '       
; void str_arruma_crlf(char *string);
str_arruma_crlf:		push edi
				mov  edi, [esp + 8]     ; string
				dec  edi
.Volta:				inc  edi
				mov  al, [edi]
				test al, al
				jz   .Fim
				cmp  al, 13
				je   .Trocar
				cmp  al, 10
				je   .Trocar
				jmp  .Volta
.Trocar:			mov  [edi], byte ' '
				jmp  .Volta
.Fim:				pop  edi
				ret
;======================================================= 
; Funcao semelhante a strncpy, porem, retorna o numero   
; de bytes copiados, pra quando encontra ZERO e tem     
; protecao contra buffer overflow                        
; unsigned int selor_strncpy(char *destino, char *origem, unsigned int tam_str)
selor_strncpy:			push edi
				push esi
				push ecx
				mov  edi, [esp + 16]  ; destino 
				mov  esi, [esp + 20]  ; origem  
				mov  ecx, [esp + 24]  ; tam_str 
				dec  ecx              ; Reversando um espaco para o ZERO final de string
				push ebx
				mov  ebx, esi
.Volta:				lodsb
				stosb
				test al, 0FFh
				jz   .Fim
				loop .Volta
				inc  esi
.Fim:				mov  [edi], byte 0
				mov  eax, esi
				sub  eax, ebx
				dec  eax              ; EAX = Bytes copiados
				pop  ebx
				pop  ecx
				pop  esi
				pop  edi
				ret
;======================================================= 
; Funcao semelhante a strncpy, porem, retorna o numero   
; de bytes copiados, pra quando encontra ZERO, protecao 
; contra buffer_overflow e converte '\n' em codig. 10    
; unsigned int special_cp(char *destino, char *origem, unsigned int tam_str)
special_cp:			push edi
				push esi
				push ecx
				mov  edi, [esp + 16]  ; destino 
				mov  esi, [esp + 20]  ; origem  
				mov  ecx, [esp + 24]  ; tam_str 
				dec  ecx              ; Reversando um espaco para o ZERO final de string
				push ebx
				mov  ebx, edi
.Volta:				lodsb
				cmp  al, 92           ; 92 --> '\'
				je   .Converter
.Copiar:			stosb
				test al, 0FFh
				jz   .Fim
				loop .Volta
				inc  esi
.Fim:				mov  [edi], byte 0
				mov  eax, edi
				sub  eax, ebx
				dec  eax              ; EAX = Bytes copiados
				pop  ebx
				pop  ecx
				pop  esi
				pop  edi
				ret
.Converter:			lodsb
				cmp  al, 'n'
				je   .Trocar_n
				cmp  al, 't'
				jne  .Copiar
				mov  al, 9           ; 10 = TAB
				jmp  .Copiar
.Trocar_n:			mov  al, 10          ; 10 = Nova linha
				jmp  .Copiar
;======================================================= 
; Funcao para juntar varias strings em uma so            
; O ultimo parametro passado deve ser NULL               
; Retornos:                                              
; EAX = Tamanho da nova string                           
;unsigned int selor_superstrncpy(char *destino, unsigned int tam_str, ...);    OBS: O ultmo parametro DEVE ser sempre NULL
selor_superstrncpy:		push edi
				push esi
				push ecx
				push ebp
				mov  edi, [esp + 20]  ; destino 
				mov  ecx, [esp + 24]  ; tam_str 
				dec  ecx              ; Reversando um espaco para o ZERO final de string
				mov  ebp, esp
				add  ebp, 24          ; 24 + 4 = Primeiro parametro dos '...'
.Prox_string:			add  ebp, 4           ;Proximo parametro '...'
.Ini_cpy:			mov  esi, [ebp]
				test esi, esi
				jz   .Fim
.Volta:				lodsb
				test  al, al
				jz   .Prox_string
				stosb
				loop .Volta
.Fim:				mov  [edi], byte 0
				mov  eax, edi
				sub  eax, [esp + 20]   ;PTR de destino final menos destino inicial = tamanho da nova string 
				pop  ebp
				pop  ecx
				pop  esi
				pop  edi
				ret
;======================================================= 
; Funcao semelhante a strncat, porem, retorna o numero   
; de bytes da nova string, pra quando encontra ZERO e   
; tem protecao contra buffer overflow                    
; unsigned int selor_strncat(char *destino, char *origem, unsigned int tam_str);
selor_strncat:			push edi
				push esi
				push ecx
				push ebx
				mov  edi, [esp + 20]  ; destino 
				mov  esi, [esp + 24]  ; origem  
				mov  ecx, [esp + 28]  ; tam_str 
				dec  ecx              ; Reversando um espaco para o ZERO final de string
				mov  ebx, edi
				xor  al, al
				repne scasb
				test ecx, ecx
				jz   .Fim
				dec  edi
				inc  ecx
.Volta:				lodsb
				test al, 0FFh
				jz   .Fim
				stosb
				loop .Volta
.Fim:				mov  [edi], byte 0
				mov  eax, edi
				sub  eax, ebx
				pop  ebx
				pop  ecx
				pop  esi
				pop  edi
				ret
;======================================================= 
; Funcao para comparar duas strings desconciderando      
; a diferena entre maisculas e minsculas              
; Retornos:                                              
; EAX = 0 -> Strings sao iguais                          
;       1 -> Diferentes                                  
; int cmp_str(char *string1, char *string2, int num_bytes)
cmp_str:			push edi
				push esi
				push ecx
				mov  edi, [esp + 16]  ; string1 
				mov  esi, [esp + 20]  ; string2 
				mov  ecx, [esp + 24]  ; num_bytes 
				test ecx, ecx
				jz   .Testar_zero
.Volta:				lodsb
				cmp  al, [edi]
				jne  .Trocar
.Incrementar:			inc  edi
				loop .Volta
				jmp  .Igual
.Trocar:			cmp  al, 65           ; Para evitar caracs 0 ou 32
				jb   .Dif
				xor  al, 32
				cmp  al, [edi]
				je   .Incrementar
.Term:				test  ecx, ecx
				jz   .Igual
.Dif:				mov  eax, 1
				pop  ecx
				pop  esi
				pop  edi
				ret
.Testar_zero:			mov  al, [esi]
				cmp  al, [edi]
				jne  .Dif
.Igual:				xor  eax, eax
				pop  ecx
				pop  esi
				pop  edi
				ret
;======================================================= 
; Funcao para comparar duas strings desconciderando      
; a diferena entre maisculas e minsculas sem          
; precisar especificar o tamanho de uma delas            
; Retornos:                                              
; EAX = 0 -> Strings sao iguais                          
;       1 -> Diferentes                                  
; int cmp_str_vars(char *string1, char *string2)
cmp_str_vars:			push esi
				push edi
				mov  edi, [esp + 12]  ; string1 
				mov  esi, [esp + 16]  ; string2 
				dec  edi
.Volta:				inc  edi
				lodsb
				cmp  al, [edi]
				jne  .Trocar
				test al, al
				jz   .Igual
				jmp  .Volta
.Trocar:			xor  al, 32
				cmp  al, [edi]
				je   .Volta
				mov  eax, 1
				pop  esi
				pop  edi
				ret
.Igual:				xor  eax, eax
				pop  edi
				pop  esi
				ret
;======================================================= 
; Funcao para decodificar uma string em base64           
; Retornos:                                              
; EAX = Retorna o tamanho do novo buffer decodificado    
;unsigned int base64_decod(char *str_destino, char *str_base64)
base64_decod:                   push esi
				push edi
				push ebx
				push ecx
				push edx
				mov  esi, [esp + 28]  ; str_base64  
				mov  edi, esi
				cld
				xor  eax, eax
				mov  ecx, 0FFFFFFFFh
				repne scasb
				dec  edi
				mov  ecx, edi
				sub  ecx, esi
				cmp  ecx, 4
				jb   .Base_invalida
				shr  ecx, 2           ; Dividindo tamanho por 4
				mov  edx, ecx
				mov  edi, [esp + 24]  ; str_destino 
				add  esi, 3
				std
				mov  ebx, base64_reversa
.Prox_casa:			lodsb                 ;                         
				xlatb                 ;  Esta parte podia ter   
				ror  eax, 6           ;  sido feita com loop,   
				lodsb                 ;  mas preferi assim para 
				xlatb                 ;  gastar menos proc.     
				ror  eax, 6           ;  por excluir o uso de   
				lodsb                 ;  loop, push e pop para  
				xlatb                 ;  salvar o valor de ecx  
				ror  eax, 6           ;                         
				lodsb                 ;                         
				xlatb                 ;                         
				ror  eax, 6           ;                         
				xchg al, ah
				ror  eax, 16
				xchg al, ah
				mov  [edi], eax
				add  edi, 3
				add  esi, 8
				loop .Prox_casa
				sub  esi, 4
				xor  ecx, ecx
.Acha_fim:			cmp  [esi], byte '='				
				jne  .Fim
				dec  esi
				dec  edi
				inc  ecx
				jmp  .Acha_fim
.Fim:				mov  [edi], byte 0
				mov  eax, edx
				xor  edx, edx
				mov  ebx, 3
				mul  ebx
				sub  eax, ecx
.Base_invalida:			cld
				pop  edx
				pop  ecx
				pop  ebx
				pop  edi
				pop  esi
				ret
;======================================================= 
; Funcao para codificar uma string em base64             
; Retornos:                                              
; EAX = Retorna o tamanho do novo buffer codificado      
;unsigned int base64_codify(char *str_base64, char *str_texto, int tamanho);
base64_cod:			push esi
				push edi
				push ebx
				push ecx
				push edx
				xor  edx, edx
				mov  edi, [esp + 24]   ; str_base64 
				mov  esi, [esp + 28]   ; str_texto  
				mov  eax, [esp + 32]   ; tamanho    
				mov  ebx, 3
				div  ebx
				mov  ecx, eax
				mov  ebx, base64_tab
				std
				push dx
				test dl, dl
				jz   .Prox_bloco
				inc  ecx
.Prox_bloco:			mov  eax, [esi]
				ror  ax, 8
				ror  eax, 16
				ror  ax, 8
				shr  eax, 6
				shr  al, 2
				add  edi, 3
				xlatb
				stosb
				shr  eax, 6
				shr  al, 2
				xlatb
				stosb
				shr  eax, 6
				shr  al, 2
				xlatb
				stosb
				shr  eax, 6
				shr  al, 2
				xlatb
				stosb
				shr  eax, 6
				add  edi, 5
				add  esi, 3
				loop .Prox_bloco
				cld
				pop  dx
				test dl, dl
				jz   .Fim
				mov  ecx, 3
				sub  cl, dl
				sub  edi, ecx
				mov  [edi], byte '='
				dec  cl
				inc  edi
				test cl, cl
				jz   .Fim
				mov  [edi], byte '='
				inc  edi
.Fim:				mov  [edi], byte 0
				mov  eax, edi
				mov  ebx, [esp + 24]
				sub  eax, ebx
				mov  [edi], byte 0
				pop  edx
				pop  ecx
				pop  ebx
				pop  edi
				pop  esi
				ret
;======================================================= 
; Funcao para copiar os enderecos de email arrumando     
; caracteres invalidos                                   
; Retorno:                                               
; --> Numero de @ encontrados                            
;unsigned int selor_segcp_min(char *destino, char *origem)
selor_segcp:			push esi
				push edi
				push ecx
				push ebx
				mov  edi, [esp + 20]
				mov  esi, [esp + 24]
				xor  ecx, ecx
				mov  ebx, base_val_email      ; Base contendo bytes validos
.Volta:				lodsb
				cmp  al, 'Z'
				ja   .Copiar
				cmp  al, 'A'
				jb   .Copiar
;				or   al, 100000b                  ; Convertendo para minusculo. Foi desativado para nao dar problema com o SRS
.Copiar:			stosb
				test al, al
				jz   .Fim
				cmp  al, '@'
				je   .Arroba
.Xlat:				xlatb
				test al, al
				jnz  .Volta
				dec  edi
				jmp  .Volta
.Arroba:			inc  ecx
				jmp  .Xlat
.Fim:				mov  eax, ecx
				pop  ebx
				pop  ecx
				pop  edi
				pop  esi
				ret
;======================================================= 
; Procura por caracteres invalidos para previnir         
; Selor Script injection no 'helo'                       
; Retorno:                                               
;  0 = Str valida                                        
;  1 = Str invalida                                      
;char t_inject(char *str)
t_inject_helo:			push esi
				push ebx
				push edx
				mov  esi, [esp + 16]
				mov  ebx, base_val_email
				mov  dl, [ebx + 20h]     ; Salvando status do ' '
				mov  dh, [ebx + 5bh]     ; Salvando status do '['
				shl  edx, 8
				mov  dl, [ebx + 5dh]     ; Salvando status do ']'
				mov  [ebx + 20h], byte 1 ; Alterando status para aceitar ' '
				mov  [ebx + 5bh], byte 1 ; Alterando status para aceitar '['
				mov  [ebx + 5dh], byte 1 ; Alterando status para aceitar ']'
.Volta:				lodsb
				test al, al
				jz   .Ok
				xlatb
				test al, al
				jnz  .Volta
				mov  eax, 1
				jmp  .Fim
.Ok:				xor  eax, eax
.Fim:				mov  [ebx + 5dh], dl     ; Restaurando status de ']'
				shr  edx, 8
				mov  [ebx + 5bh], dh     ; Restaurando status de '['
				mov  [ebx + 20h], dl     ; Restaurando status de ' '
				pop  edx
				pop  ebx
				pop  esi
				ret
;======================================================= 
; Arruma o buffer recebido pelo cliente. O ENTER com     
; codigo 13,10 vai para 10 e o '\n..' vai para '\n.'     
; Retornos:                                              
; EAX -> Tamanho do novo buffer                          
; A variavel fim_header  alterada quando o fim do header
;  encontado. Ela retorna a posicao dele no buffer de   
; destino                                                
;int conv_crlf(char *destino, char *origem, int num_bytes, char *ult_buffer, char **fim_header);
conv_crlf:			push edi
				push esi
				push ecx
				push edx
				push ebx
				mov  esi, [esp + 28] ; origem 
				mov  ecx, [esp + 32] ; num_bytes 
				mov  ebx, [esp + 40] ; fim_header
				mov  ebx, [ebx]
				test ebx, ebx
				jz   .Header_n_detectado
				cmp  [esi], byte '.'
				jne  .Inicio
				mov  edi, [esp + 36] ; ult_buffer 
				inc  esi
				dec  ecx
				cmp  [edi], word 2E0Ah ;2E0Ah = '\n.'
				je   .Inicio
				dec  esi
				inc  edi
				inc  ecx
				cmp  [edi], byte 10
				jne  .Inicio
				inc  esi
				dec  ecx
				cmp  [esi], byte '.'
				je   .Inicio
				inc  ecx
				dec  esi
.Inicio:			mov  edi, [esp + 24] ; destino 
				mov  edx, edi
.Prox_byte:			lodsb
				cmp  al, 13
				je   .Nao_copiar
				cmp  al, '.'
				je   .Ponto
.Copiar:			stosb
.Nao_copiar:			loop .Prox_byte
.Fim:				mov  eax, edi
				sub  eax, edx        ; Tam do buffer em EAX
				pop  ebx
				pop  edx
				pop  ecx
				pop  esi
				pop  edi
				ret
.Ponto:				cmp  [esi - 2], byte 10
				jne  .Copiar
				dec  ecx
				inc  esi
				cmp  [esi - 1], byte '.'
				je   .Copiar
				dec  esi
				inc  ecx
				jmp  .Copiar
	; --------- Funcao duplicada com busca de fim de header --------- 
.Header_n_detectado:		cmp  [esi], byte 10
				je   .Header_detect_inicio
				cmp  [esi], word 2573 ; 2573 = \r\n
				je   .Header_detect_inicio
				cmp  [esi], byte '.'
				jne  .Inicio2
				mov  edi, [esp + 36] ; ult_buffer 
				inc  esi
				dec  ecx
				cmp  [edi], word 2E0Ah ;2E0Ah = '\n.'
				je   .Inicio2
				dec  esi
				inc  edi
				inc  ecx
				cmp  [edi], byte 10
				jne  .Inicio2
				inc  esi
				dec  ecx
				cmp  [esi], byte '.'
				je   .Inicio2
				inc  ecx
				dec  esi
.Inicio2:			mov  edi, [esp + 24] ; destino 
				mov  edx, edi
.Prox_byte2:			lodsb
				cmp  al, 13
				je   .Nao_Copiar2
				cmp  al, '.'
				je   .Ponto2
				cmp  al, 10
				je  .Header_detect
.Copiar2:			stosb
.Nao_Copiar2:			loop .Prox_byte2
				jmp  .Fim
.Ponto2:			cmp  [esi - 2], byte 10
				jne  .Copiar2
				dec  ecx
				inc  esi
				cmp  [esi - 1], byte '.'
				je   .Copiar2
				dec  esi
				inc  ecx
				jmp  .Copiar2
.Header_detect_inicio:		mov  edi, [esp + 36] ; ult_buffer 
				inc  edi
				cmp  [edi], byte 10
				jne  .Inicio2
				mov  edi, [esp + 24] ; destino 
				mov  edx, edi
				lodsb
				mov  ebx, [esp + 40] ; fim_header
				mov  [ebx], edi
				jmp  .Copiar
.Header_detect:			cmp  [edi - 1], byte 10
				jne  .Copiar2
				mov  ebx, [esp + 40] ; fim_header
				mov  [ebx], edi
				jmp  .Copiar

;======================================================= 
; Funcao para ler um buffer lido e separa-lo em linhas   
; Retornos:                                              
; EAX -> 0 = Linha pronta para ser lida                  
;        1 = Novo buffer  necessario                    
;int cpl(struct cpl_struct *)
cpl:				push ebp
				mov  ebp, [esp + 8]  ; struct cpl_struct 
				push esi
				push edi
				push ecx
				mov  esi, [ebp]      ; cpl_struct.orig 
				mov  edi, [ebp + 4]  ; cpl_struct.dest 
				mov  ecx, [ebp + 8]  ; cpl_struct.tamusado 
				test ecx, ecx
				jz   .Arrumar
.Volta:				lodsb
				cmp  al, 10
				je   .Finalizar
				test al, al
				jz   .Zero
				cmp  al, 13
				je   .Pular_13
				stosb
.Pular_13:			loop .Volta
.Arrumar:			lodsb
				cmp  al, 10
				je   .Finalizar
				test al, al
				jnz  .Arrumar
.Zero:				mov  eax, 1
				jmp  .Fim
.Finalizar:			mov  ecx, [ebp + 12]  ; cpl_struct.tambuffer
				xor  eax, eax
.Fim:				mov  [ebp], esi
				mov  [edi], byte 0    ;Finalizando a string com ZERO
				mov  [ebp + 4], edi
				mov  [ebp + 8], ecx
				pop  ecx
				pop  edi
				pop  esi
				pop  ebp
				ret
;struct cpl_struct {
; unsigned int orig;
; unsigned int dest;
; unsinged int tamusado;
; unsigned int tambuffer;
;}
;======================================================= 
; Funcao para transformar um valor decimal (32 bits)para 
; o mesmo valor escrito em forma de texto	         
; Retonos:                                               
; EAX -> Ponteiro para a string convertida               
;char *itoa(unsigned int valor, int num_casas);
itoa:				push edi
				push ebx
				push ecx
				push edx
				mov  ecx, TAM_str_itoa
				mov  edi, texto_itoa
				mov  al, '0'
				rep  stosb
				mov  eax, [esp + 20]  ; valor     
				mov  ecx, [esp + 24]  ; num_casas 
				cmp  eax, 10
				jb   .Ult_carac
				mov  ebx, 10
.Prox:				xor  edx, edx
				div  ebx
				add  dl, 48
				dec  edi
				mov  [edi], dl
				cmp  eax, 10
				jae  .Prox
.Ult_carac:			add  al, 48
				dec  edi
				mov  [edi], al
				and  ecx, 0Fh        ; Maximo de 15 zeros possiveis 
				mov  eax, texto_itoa + TAM_str_itoa
				sub  eax, ecx
				cmp  eax, edi
				jb   .Fim
				mov  eax, edi
.Fim:				pop  edx
				pop  ecx
				pop  ebx
				pop  edi
				ret
;======================================================= 
; Funcao para testar se um IP esta contido em uma rede   
; Retornos:                                              
; EAX = 0 -> Nao esta contido                            
;     = 1 -> Esta contido                                
;char tmasc(unsigned int ip, unsigned int rede, unsigned short mascara);
tmasc:				push ebx
				push cx
				mov  ax,  [esp + 18]   ; mascara 
				cmp  ax, 32
				ja   .Diferente
				mov  cx, 32
				sub  cx, ax
				mov  eax, [esp + 10]   ; IP      
				mov  ebx, [esp + 14]   ; rede    
				test cx, cx
				jz   .Comparar
				ror  ax, 8
				ror  eax, 16
				ror  ax, 8
				ror  bx, 8
				ror  ebx, 16
				ror  bx, 8
				shr  eax, cl
				shr  ebx, cl
.Comparar:			cmp  eax, ebx
				je   .Igual
.Diferente:			xor  eax, eax
				pop  cx
				pop  ebx
				ret
.Igual:				mov  eax, 1
				pop  cx
				pop  ebx
				ret
;======================================================= 
; Funcao para varrer um vetor a procura de um possivel   
; ataque DoS                                             
; Retornos:                                              
; EAX = 0 -> Nada detectado                              
;       1 -> Possivel ataque DoS detectado               
;char dosd(struct str_dosd *)
dosd:				push ebp
				mov  ebp, [esp + 8]
				push esi
				push edi
				push ebx
				push ecx
				push edx
				xor  ecx, ecx
				xor  edx, edx
				mov  eax, [DOSD_timestamp]
				mov  edi, [DOSD_atual_posi]
				mov  [edi + 4], eax
				mov  eax, [DOSD_ip]
				mov  [edi], eax
				mov  esi, [DOSD_fim_mem]
.Volta_01:			add  edi, 8
				cmp  edi, esi
				jae  .Ver_outro_lado
				cmp  eax, [edi]
				jne  .Volta_01
				mov  ebx, [edi + 4]
				sub  ebx, ecx
				mov  ecx, [edi + 4]
				cmp  ebx, [DOSD_intervalo]
				ja   .Volta_01
				inc  edx
				jmp  .Volta_01
.Ver_outro_lado:		mov  esi, [DOSD_atual_posi]
				mov  edi, [DOSD_mem]
.Volta_02:			cmp  eax, [edi]
				je   .Computar
.Checar_final:			add  edi, 8
				cmp  edi, esi
				jbe  .Volta_02
				xor  eax, eax
				cmp  edx, [DOSD_num_ocorr]
				jb   .Finalizar
				inc  eax
.Finalizar:			mov  esi, [DOSD_fim_mem]  
				sub  esi, 8
				cmp  esi, [DOSD_atual_posi]
				ja   .Adicionar
				mov  esi, [DOSD_mem]
				mov  [DOSD_atual_posi], esi
				jmp  .Final
.Adicionar:			add  [DOSD_atual_posi], dword 8
.Final:				pop  edx
				pop  ecx
				pop  ebx
				pop  edi
				pop  esi
				pop  ebp
				ret
.Computar:			mov  ebx, [edi + 4]
				sub  ebx, ecx
				mov  ecx, [edi + 4]
				cmp  ebx, [DOSD_intervalo]
				ja   .Checar_final
				inc  edx
				jmp  .Checar_final
;struct str_dosd {            
; unsigned int ip             
; unsigned int timestamp      
; char *mem                   
; char *fim_mem               
; char *atual_posi            
; unsigned int intervalo      
; unsigned int num_ocorrencias
;}                          
;======================================================= 


