/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   SELOR - Servidor de Emails Livre Orientado a Regras                           
   Programado por Lucas Priori                                                   
   Versao: 1.1                                                                   
                                                                                 
   Linux - make linux                                                            
   FreeBSD - gmake freebsd                                                       
                                                                                 
  *******************************************************************            
  Selor e um agente MTA para troca de emails via protocolo SMTP                 
  Copyright (C) 2012,2013,2014  Lucas Priori                                     
                                                                                 
  This program is free software; you can redistribute it and/or                  
  modify it under the terms of the GNU General Public License                    
  as published by the Free Software Foundation; either version 2                 
  of the License, or (at your option) any later version.                         
                                                                                 
  This program is distributed in the hope that it will be useful,                
  but WITHOUT ANY WARRANTY; without even the implied warranty of                 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  
  GNU General Public License for more details.                                   
                                                                                 
  You should have received a copy of the GNU General Public License              
  along with this program; if not, write to the Free Software                    
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

#ifndef SO_MARK
 #define SO_MARK 36
#endif

#ifndef GLOBAL
 #define GLOBAL
 // -----------
 #define VERSAO "1.1"
 #ifndef CAM_arq_conf
  #define CAM_arq_conf "/usr/local/selor/selor.conf"
 #endif
 // --
 #define NUM_opcoes 109
 #define OP_DEF_ON 1         // Def! LIGADA
 #define OP_DEF_OFF 0        // Def! DESLIGADA
 #define OP_INT 2            // A Opcao e um NUMERO
 // --
 #define PORTA_padrao 25
 #define MAX_modules 4
 #define TAM_dominio 100
 #define MAX_adomain_resolvs 3
 #define MAX_msgs_per_cnx 100
 #define TAM_defs 130
 #define TAM_defs_modseqs (MAX_modules * 10)
 #define TAM_id_fila 70
 #define TAM_smtp_cmd 300
 #define TAM_buffer 4096
 #define TAM_buffer_log 2000
 #define TAM_mark 70
 #define TAM_helo 100
 #define TAM_endereco 120           // As RFCs dizem que deve ser 254 caracteres,                   
                                    // mas isso ocuparia muita memoria e  completamente            
                                    // desnecessario ja que  extremamente dificil um email maior do
                                    // que 90 caracateres                                           
 #define MAX_buffer_alias 10
 #define TAM_email_resp 200
 #define TAM_cam_email 200
 #define TAM_email_dest 120
 #define TAM_email_auth 120
 #define TAM_home 200
 #define TAM_exec_str 150
 #define TAM_subdirs 100
 #define TAM_srs_key 50
 #define AUTH_LOGIN_u "334 VXNlcm5hbWU6\0"       // Significa 'Username:' em MIME64
 #define AUTH_LOGIN_p "334 UGFzc3dvcmQ6\0"       // Significa 'Password:' em MIME64
 #define NUM_smtp_resps 30
 #define NVL_log_desativado 0
 #define NVL_log_rec 1
 #define NVL_log_env 2
 #define NVL_log_rec_env 3
 #define MAX_query_mx 30
 #define MAX_ips_locais 20
 #define TAM_mod_name 50
 #define NUM_filas 2
 #define MAX_spf_recursividade 5
 #define Localhost 0x100007F
 // --- STATUS ---
 #define STATUS_PENDENTE ' '
 #define STATUS_FINALIZADO '@'
 #define STATUS_ENTREGUE '*'
 #define STATUS_ERRO_TEMP '?'
 #define STATUS_TARPIT '+'
 #define STATUS_ERRO '!'
 // --------------
 #define ETAPA_helo 0
 #define ETAPA_mail_from 1
 #define ETAPA_rcpt_to 2
 #define ETAPA_data 3
 // --------------
 #define MOD_user_ncampos 4
 #define MOD_user_user 0
 #define MOD_user_pass 1
 #define MOD_user_home 2
 #define MOD_user_dlocal 3
 //--- Tipos das Mensagens de protocolo ----
 #define MSG_invalid_cmd 0             //500
 #define MSG_invalid_param 1           //501
 #define MSG_sequence_error 2          //503
 #define MSG_no_mailbox 3              //550
 #define MSG_relay_denied 4            //550
 #define MSG_transaction_falied 5      //554
 #define MSG_ok 6                      //250
 #define MSG_resp_ehlo 7               //250
 #define MSG_send_body 8               //354
 #define MSG_server_name 9             //250
 #define MSG_allowed_sender 10         //250
 #define MSG_allowed_rcpt 11           //250
 #define MSG_welcome 12                //220
 #define MSG_goodbye 13                //221
 #define MSG_auth_ok 14                //235
 #define MSG_auth_falied 15            //235
 #define MSG_toomany_rcpts 16          //550
 #define MSG_auth_required 17          //550
 #define MSG_auth_login_u 18           //334
 #define MSG_auth_login_p 19           //334
 #define MSG_nodisk_space 20           //452
 #define MSG_perm_deny 21              //421
 #define MSG_invalid_domain 22         //553
 #define MSG_header_toobig 23          //451
 #define MSG_full_mailbox 24           //552
 #define MSG_internal_error 25         //451
 #define MSG_mail_toobig 26            //552
 #define MSG_lavg 27                   //550
 #define MSG_refused 28                //550
 #define MSG_mail_accepted 29          //250
 //-----------------------------------------
 #define Server_name                  0                            // -- Defines Texto --
 #define Event_limit                  1
 #define Event_connection             2
 #define Event_helo                   3
 #define Event_rcpt                   4
 #define Event_from                   5
 #define Event_data                   6
 #define User                         7
 #define Group                        8
 #define Cp_errors_path               9
 #define Temp_path                    10
 #define Queue_path                   11
 #define Report_file                  12
 #define Pid_file                     13
 #define Central_log                  14
 #define Sumary_log                   15
 #define Warning_log                  16
 #define Module                       17
 #define Dlocal                       18
 #define Adlocal_allowed              19
 #define Welcome_msg                  20
 #define Msg_full_mailbox             21
 #define Msg_invalid_cmd              22
 #define Msg_invalid_param            23
 #define Msg_sequence_error           24
 #define Msg_no_mailbox               25
 #define Msg_toomany_rcpts            26
 #define Msg_relay_denied             27
 #define Msg_transaction_falied       28
 #define Msg_ok                       29
 #define Msg_send_body                30
 #define Msg_allowed_sender           31
 #define Msg_refused                  32
 #define Msg_allowed_rcpt             33
 #define Msg_mail_accepted            34
 #define Msg_goodbye                  35
 #define Msg_auth_ok                  36
 #define Msg_auth_falied              37
 #define Msg_auth_required            38
 #define Msg_nodisk_space             39
 #define Msg_perm_deny                40
 #define Msg_invalid_domain           41
 #define Msg_header_toobig            42
 #define Msg_internal_error           43
 #define Msg_cannot_connect           44
 #define Msg_mailbox_unavaibble       45
 #define Msg_mail_toobig              46
 #define Msg_lavg                     47
 #define Postmaster                   48
 #define Subject_error_msg            49
 #define Report_from                  50
 #define Msg_cannot_resolve           51
 #define Timezone                     52
 #define Sid                          53
 #define Log_lvl                      54
 #define Port                         55
 #define Max_rcpts                    56
 #define Max_mail_size                57
 #define Max_attempts                 58
 #define Max_header_size              59
 #define Max_error_report             60
 #define Max_qprocs                   61
 #define Qlimit_max_procs             62
 #define Qlimit_time                  63
 #define Qsleep_time                  64
 #define Connect_timeout              65
 #define Mx_alias_ip                  66
 #define Cp_errors                    67
 #define Resolve_all                  68
 #define Hshow_user                   69
 #define Proto_level_check            70
 #define Incorrect_pass_delay         71
 #define Auth_tolerance               72
 #define Limit_buf                    73
 #define Limit_cnx                    74
 #define Limit_time                   75
 #define Immed_delivery               76
 #define Timeout                      77
 #define Queue_time                   78
 #define No_mailbox_delay             79
 #define Auth_relay                   80
 #define From_level_check             81
 #define Rcpt_level_check             82
 #define Lavg_queue                   83
 #define Lavg_negative                84
 #define Tarpit_sleep                 85
 #define Tarpit_limit                 86
 #define Tls_module                   87
 #define Tls_cafile                   88
 #define Tls_pubkey                   89
 #define Tls_privkey                  90
 #define Tls_enable                   91
 #define Tls_delivery                 92
 #define Refused_log                  93
 #define Event_qend_process           94
 #define Force_alias_seek             95
 #define Modseq_auth                  96
 #define Modseq_domain                97
 #define Modseq_mail                  98
 #define Modseq_alias                 99
 #define Seek_df_alias                100
 #define Srs_key                      101
 #define Srs_shift                    102
 #define Srs_alias_redir              103
 #define Event_error_report           104
 #define Max_msgs_per_cnx             105
 #define Event_dl_rcpt                106
 #define Event_lrcpt_refused          107
 #define Df_domain			          108
 //-----------------------------------------------
#endif



// --------------------------------------
//          Variaveis GLOBAIS            
// --------------------------------------
#ifndef _MAIN_
 // -- Variaveis das OPCOES do arquivo de configuracao --
 extern char DEF_server_name[TAM_defs];
 extern char DEF_event_limit[TAM_defs];
 extern char DEF_event_connection[TAM_defs];
 extern char DEF_event_helo[TAM_defs];
 extern char DEF_event_rcpt[TAM_defs];
 extern char DEF_event_from[TAM_defs];
 extern char DEF_event_data[TAM_defs];
 extern char DEF_event_qend_process[TAM_defs];
 extern char DEF_event_error_report[TAM_defs];
 extern char DEF_event_dl_rcpt[TAM_defs];           // Recipient Delivery
 extern char DEF_event_lrcpt_refused[TAM_defs];
 extern char DEF_user[50];
 extern char DEF_group[50];
 extern char DEF_cp_errors_path[TAM_defs];
 extern char DEF_temp_path[TAM_defs];
 extern char DEF_queue_path[TAM_defs];
 extern char DEF_report_file[TAM_defs];
 extern char DEF_pid_file[TAM_defs];
 extern char DEF_central_log[TAM_defs];
 extern char DEF_sumary_log[TAM_defs];
 extern char DEF_warning_log[TAM_defs];
 extern char DEF_refused_log[TAM_defs];
 extern char DEF_module[MAX_modules][TAM_defs];
 extern char DEF_tls_module[TAM_defs];
 extern char *DEF_tls_module_p;
 extern char DEF_tls_cafile[TAM_defs];
 extern char DEF_tls_pubkey[TAM_defs];
 extern char DEF_tls_privkey[TAM_defs];
 extern char DEF_dlocal[TAM_defs];
 extern char DEF_adlocal_allowed[TAM_defs];
 extern char DEF_welcome_msg[TAM_defs];
 extern char DEF_df_domain[TAM_defs];
 extern char DEF_msg_full_mailbox[TAM_defs];
 extern char DEF_msg_invalid_cmd[TAM_defs];
 extern char DEF_msg_invalid_param[TAM_defs];
 extern char DEF_msg_sequence_error[TAM_defs];
 extern char DEF_msg_no_mailbox[TAM_defs];
 extern char DEF_msg_toomany_rcpts[TAM_defs];
 extern char DEF_msg_relay_denied[TAM_defs];
 extern char DEF_msg_transaction_falied[TAM_defs];
 extern char DEF_msg_ok[TAM_defs];
 extern char DEF_msg_send_body[TAM_defs];
 extern char DEF_msg_allowed_sender[TAM_defs];
 extern char DEF_msg_refused[TAM_defs];
 extern char DEF_msg_allowed_rcpt[TAM_defs];
 extern char DEF_msg_mail_accepted[TAM_defs];
 extern char DEF_msg_goodbye[TAM_defs];
 extern char DEF_msg_auth_ok[TAM_defs];
 extern char DEF_msg_auth_falied[TAM_defs];
 extern char DEF_msg_auth_required[TAM_defs];
 extern char DEF_msg_nodisk_space[TAM_defs];
 extern char DEF_msg_perm_deny[TAM_defs];
 extern char DEF_msg_invalid_domain[TAM_defs];
 extern char DEF_msg_header_toobig[TAM_defs];
 extern char DEF_msg_internal_error[TAM_defs];
 extern char DEF_msg_cannot_connect[TAM_defs];
 extern char DEF_msg_mailbox_unavaibble[TAM_defs];
 extern char DEF_msg_mail_toobig[TAM_defs];
 extern char DEF_msg_lavg[TAM_defs];
 extern char DEF_postmaster[100];
 extern char DEF_subject_error_msg[TAM_defs];
 extern char DEF_report_from[TAM_defs];
 extern char DEF_msg_cannot_resolve[TAM_defs];
 extern char DEF_timezone[10];
 extern char DEF_sid[10];
 extern char DEF_modseq_auth[TAM_defs_modseqs];
 extern char DEF_modseq_domain[TAM_defs_modseqs];
 extern char DEF_modseq_mail[TAM_defs_modseqs];
 extern char DEF_modseq_alias[TAM_defs_modseqs];
 extern char DEF_srs_key[TAM_srs_key];
 extern unsigned int DEF_log_lvl;
 extern unsigned int DEF_port;
 extern unsigned int DEF_max_rcpts;
 extern unsigned int DEF_max_mail_size;
 extern unsigned int DEF_max_attempts;
 extern unsigned int DEF_max_header_size;
 extern unsigned int DEF_max_error_report;
 extern unsigned int DEF_max_qprocs;
 extern unsigned int DEF_qlimit_max_procs;
 extern unsigned int DEF_qlimit_time;
 extern unsigned int DEF_qsleep_time;
 extern unsigned int DEF_connect_timeout;
 extern unsigned int DEF_mx_alias_ip;
 extern unsigned int DEF_cp_errors;
 extern unsigned int DEF_resolve_all;
 extern unsigned int DEF_hshow_user;
 extern unsigned int DEF_proto_level_check;
 extern unsigned int DEF_incorrect_pass_delay;
 extern unsigned int DEF_auth_tolerance;
 extern unsigned int DEF_limit_buf;
 extern unsigned int DEF_limit_cnx;
 extern unsigned int DEF_limit_time;
 extern unsigned int DEF_immed_delivery;
 extern unsigned int DEF_immed_delivery_bk;
 extern unsigned int DEF_timeout;
 extern unsigned int DEF_queue_time;
 extern unsigned int DEF_no_mailbox_delay;
 extern unsigned int DEF_auth_relay;
 extern unsigned int DEF_from_level_check;
 extern unsigned int DEF_rcpt_level_check;
 extern unsigned int DEF_lavg_queue;
 extern unsigned int DEF_lavg_negative;
 extern unsigned int DEF_tarpit_sleep;
 extern unsigned int DEF_tarpit_limit;
 extern unsigned int DEF_tls_enable;
 extern unsigned int DEF_tls_delivery;
 extern unsigned int DEF_force_alias_seek;
 extern unsigned int DEF_seek_df_alias;
 extern unsigned int DEF_srs_shift;
 extern unsigned int DEF_srs_alias_redir;
 extern unsigned int DEF_max_msgs_per_cnx;
 extern char nome_op[NUM_opcoes][24];
 extern void *ptr_op[NUM_opcoes];
 extern char def_ops_val[NUM_opcoes];
 extern int def_ops[NUM_opcoes];
 extern int num_ops;
 // -----------------------------------------------------
 extern char *smtp_resps[NUM_smtp_resps];
 // -----------------------------------------------------
 extern time_t tempo;
 extern struct tm *timeinfo;
 extern struct servs_tempo{
  char dia_semana[3];
  char fim1;
  char mes[3];
  char fim2;
  char dia[2];
  char fim3;
  char hora[2];
  char fim4;
  char minuto[2];
  char fim5;
  char segundo[2];
  char fim6;
  char ano[4];
  char fim7;
 }tlog;
 extern struct host_remoto{
  char ip[16];
  char nome[NS_MAXDNAME];
  char helo[TAM_helo + 1];
  char autenticado;
  char rbl;
  unsigned int ipn;
  unsigned char strlen_ip;
  unsigned int strlen_nome;
  unsigned int strlen_helo;
 }host;
 extern struct dados_email{
  char status;
  char email[TAM_endereco];
  char *dominio;
  char local;         // 0 = Dominio externo, 1 = Dominio local, -1 = Nao checado
  char resp[TAM_email_resp];
  char dest[TAM_email_dest];
  char auth[TAM_email_auth];
  int so_mark;
  char mx_source[NS_MAXDNAME];
  char *pass;
 }localhost, from, tmp_email, from_tmp, srs_tmp, *to, *atual_rcpt, *tmp_rcpt;
 extern struct struct_global_info{
  char ae;            // Aviso de entrega
 }global_info;
 extern struct str_mail_info{
  char user[TAM_endereco];
  char home[TAM_home];
 }auth_info, from_info, rcpt_info;
 extern struct str_mx_map{
  char ip[16];
  char auth[TAM_email_auth];
  unsigned int ipn;
  unsigned short porta;
  unsigned int so_mark;
  char mx_source[NS_MAXDNAME];
  int ini;
  int ult;
  char forcado;
  char finalizado;
 }*mx_map;
 extern struct str_mod_names{
  char mod_id[TAM_mod_name+1];
  int mod_index;
 }mod_names[MAX_modules];
 extern uid_t uid;
 extern gid_t gid;
 extern pid_t ppid;
 extern struct passwd *pwd;
 extern struct group *grp;
 
 // -- Variaveis de SOCKET --
 extern socklen_t tam_socket;
 extern struct sockaddr_in rede_remota;
 extern int socket_remoto;
 extern struct timeval tval;
 // -- VARIAVEIS GLOBAIS de REGRAS --
 extern char R_CLOSE;
 extern char R_ACCEPT;
 extern char R_DENY;
 extern char R_RELAY;
 extern char R_REPLY[TAM_defs];
 extern char R_DATA_REPLY[TAM_defs];
 extern char R_HADD[TAM_defs];
 extern char R_EXEC_STR[TAM_exec_str + 1];
 extern char R_RBL_TXT[NS_MAXDNAME + 1];
 extern char R_SERVER_RESP[NS_MAXDNAME + 1];
 extern char R_MARK[TAM_mark];
 extern char R_DSPOOL[TAM_defs];
 extern int R_TAM_HADD;
 extern int R_SPF;
 extern int R_HITS;
 extern int R_EXEC;
 extern int R_SO_MARK;
 // --
 extern void *modulo[MAX_modules];
 extern void *tls_mod;
 extern char mod_id[200];
 extern char mod_version[200];
 extern char etapa_smtp;
 extern char tls_ativo;
 extern char cam_filac[200];
 extern char cam_filal[200];
 extern char fpid[10];
 extern char id_pid[TAM_id_fila];
 extern char id_fila[TAM_id_fila + 1];
 extern char tam_id_fila;
 extern char smtp_cmd[TAM_smtp_cmd + 1];
 extern char buffer[TAM_buffer + 10];
 extern char linha[TAM_buffer + 10];
 extern char hostname[200];
 extern char adomain[TAM_dominio];
 extern char *mod_user_info[MOD_user_ncampos];        //Ponteiros temporarios com as informacoes extras dos usuarios
             // 0 = user           
             // 1 = password       
             // 2 = home directory 
             // 3 = dlocal         
 extern char buffer_log_completo[TAM_buffer_log + 23];
 extern char *buffer_log;
 extern char *buffer_log_juncao;
 extern char auth_user[TAM_endereco];
 extern char auth_pass[TAM_endereco];
 extern char ult_dom_int[NS_MAXDNAME];
 extern char ult_dom_ext[NS_MAXDNAME];
 extern char log_strtempo[30];
 extern char log_resumo_tipo[3];
 extern char log_resumo_size[11];
 extern char temp;
 extern char ret_val;
 extern char srs_from[TAM_endereco];
 extern char srs_rcpt[TAM_endereco];
 extern char rem_arq_signal;
 extern char ret_alias[MAX_buffer_alias][TAM_endereco];
 extern char wait_log;
 extern float etapa_global; 
 extern double load_avg;
 extern int arq_log;
 extern int modseq_auth[MAX_modules+1];
 extern int modseq_domain[MAX_modules+1];
 extern int modseq_mail[MAX_modules+1];
 extern int modseq_alias[MAX_modules+1];
 extern int num_mods;
 extern int *mx_index;
 extern int num_smtp_resp;
 extern unsigned int msg_cont;
 extern unsigned int tam_email;
 extern unsigned int num_rcpt;
 extern unsigned int num_rcpts;
 extern unsigned int prox_num_rcpt;
 extern unsigned int tam_mem_rcpts;
 extern unsigned int ips_locais[MAX_ips_locais];
 extern unsigned int tam_header;
  
#else
 // -- Variaveis das OPCOES do arquivo de configuracao --
 char DEF_server_name[TAM_defs]="localhost\0";
 char DEF_event_limit[TAM_defs]="\0";
 char DEF_event_connection[TAM_defs]="\0";
 char DEF_event_helo[TAM_defs]="\0";
 char DEF_event_rcpt[TAM_defs]="\0";
 char DEF_event_from[TAM_defs]="\0";
 char DEF_event_data[TAM_defs]="\0";
 char DEF_event_qend_process[TAM_defs]="\0";
 char DEF_event_error_report[TAM_defs]="\0";
 char DEF_event_dl_rcpt[TAM_defs]="\0";           // Recipient Delivery
 char DEF_event_lrcpt_refused[TAM_defs]="\0";
 char DEF_user[50]="selor\0";
 char DEF_group[50]="selor\0";
 char DEF_cp_errors_path[TAM_defs]="/var/spool/selor/errors\0";
 char DEF_temp_path[TAM_defs]="/tmp\0";
 char DEF_queue_path[TAM_defs]="/var/spool/selor\0";
 char DEF_report_file[TAM_defs]="/usr/local/selor/error_report.txt\0";
 char DEF_pid_file[TAM_defs]="/var/run/selor.pid\0";
 char DEF_central_log[TAM_defs]="/var/log/selor/selor.log\0";
 char DEF_sumary_log[TAM_defs]="/var/log/selor/selor_summary.log\0";
 char DEF_warning_log[TAM_defs]="/var/log/selor/selor_wrn.log\0";
 char DEF_refused_log[TAM_defs]="\0";
 char DEF_module[MAX_modules][TAM_defs]={"\0"};
 char DEF_tls_module[TAM_defs]="\0";
 char *DEF_tls_module_p=NULL;
 char DEF_tls_cafile[TAM_defs]="\0";
 char DEF_tls_pubkey[TAM_defs]="\0";
 char DEF_tls_privkey[TAM_defs]="\0";
 char DEF_dlocal[TAM_defs]="/usr/bin/procmail -d %l \0";
 char DEF_adlocal_allowed[TAM_defs]="\0";
 char DEF_welcome_msg[TAM_defs]="\0";
 char DEF_df_domain[TAM_defs]="\0";
 char DEF_msg_full_mailbox[TAM_defs]="552 The mailbox is over quota\0";
 char DEF_msg_invalid_cmd[TAM_defs]="500 Invalid command\0";
 char DEF_msg_invalid_param[TAM_defs]="501 Invalid parameter\0";
 char DEF_msg_sequence_error[TAM_defs]="503 Invalid sequence\0";
 char DEF_msg_no_mailbox[TAM_defs]="550 No such user\0";
 char DEF_msg_toomany_rcpts[TAM_defs]="452 Too many recipients\0";
 char DEF_msg_relay_denied[TAM_defs]="550 Relay denied\0";
 char DEF_msg_transaction_falied[TAM_defs]="554 Transaction error\0";
 char DEF_msg_ok[TAM_defs]="250 Ok\0";
 char DEF_msg_resp_ehlo[TAM_defs]="\0";
 char DEF_msg_send_body[TAM_defs]="354 Ok\0";
 char DEF_msg_allowed_sender[TAM_defs]="250 Sender allowed\0";
 char DEF_msg_refused[TAM_defs]="550 Refused\0";
 char DEF_msg_allowed_rcpt[TAM_defs]="250 Rcpt allowed\0";
 char DEF_msg_mail_accepted[TAM_defs]="250 Msg accepted\0";
 char DEF_msg_goodbye[TAM_defs]="221 Ok\0";
 char DEF_msg_auth_login_u[TAM_defs]=AUTH_LOGIN_u;
 char DEF_msg_auth_login_p[TAM_defs]=AUTH_LOGIN_p;
 char DEF_msg_auth_ok[TAM_defs]="235 Auth successful\0";
 char DEF_msg_auth_falied[TAM_defs]="535 Auth fail\0";
 char DEF_msg_auth_required[TAM_defs]="550 Auth required\0";
 char DEF_msg_nodisk_space[TAM_defs]="452 No disk space\0";
 char DEF_msg_perm_deny[TAM_defs]="421 Temp error. Try again later\0";
 char DEF_msg_invalid_domain[TAM_defs]="553 Invalid domain:\0";
 char DEF_msg_header_toobig[TAM_defs]="554 Header too big\0";
 char DEF_msg_internal_error[TAM_defs]="451 Internal error\0";
 char DEF_msg_cannot_connect[TAM_defs]="Could not connect to remote server\0";
 char DEF_msg_mailbox_unavaibble[TAM_defs]="451 Mailbox unavailable\0";
 char DEF_msg_mail_toobig[TAM_defs]="552 Message too big\0";
 char DEF_msg_lavg[TAM_defs]="450 Load average, try again later\0";
 char DEF_subject_error_msg[TAM_defs]="[Mail delivery error]\0";
 char DEF_postmaster[100]="postmaster@localhost\0";
 char DEF_report_from[TAM_defs]="<MAILER-DAEMON@localhost>\0";
 char DEF_msg_cannot_resolve[TAM_defs]="Invalid domain or no MX record\0";
 char DEF_timezone[10]="";
 char DEF_sid[10]="\0";
 char DEF_modseq_auth[TAM_defs_modseqs]="\0";
 char DEF_modseq_domain[TAM_defs_modseqs]="\0";
 char DEF_modseq_mail[TAM_defs_modseqs]="\0";
 char DEF_modseq_alias[TAM_defs_modseqs]="\0";
 char DEF_srs_key[TAM_srs_key]="\0";
 unsigned int DEF_log_lvl=0;
 unsigned int DEF_port=25;
 unsigned int DEF_max_rcpts=100;              // Maximo de 100 destinatarios 
 unsigned int DEF_max_mail_size=10485760;     // 10 MB                       
 unsigned int DEF_max_attempts=48;
 unsigned int DEF_max_header_size=51200;
 unsigned int DEF_max_error_report=3;
 unsigned int DEF_max_qprocs=0;               // Controle de numero de processo de fila        
 unsigned int DEF_qlimit_max_procs=0;         // Controle de numero de processos da fila qlimit
 unsigned int DEF_qlimit_time=8;
 unsigned int DEF_qsleep_time=60;             // Numero de segundos aguardando para olhar a fila
 unsigned int DEF_connect_timeout=60;
 unsigned int DEF_mx_alias_ip=0;              // Padrao = Nao resolver alias de ip de mxzes    
 unsigned int DEF_cp_errors=1;
 unsigned int DEF_resolve_all=1;
 unsigned int DEF_hshow_user=0;
 unsigned int DEF_proto_level_check=0;
 unsigned int DEF_incorrect_pass_delay=3;
 unsigned int DEF_auth_tolerance=3;
 unsigned int DEF_limit_buf=0;
 unsigned int DEF_limit_cnx=15;
 unsigned int DEF_limit_time=1;
 unsigned int DEF_immed_delivery=1;
 unsigned int DEF_immed_delivery_bk=1;
 unsigned int DEF_timeout=120;
 unsigned int DEF_queue_time=15;
 unsigned int DEF_no_mailbox_delay=2;
 unsigned int DEF_auth_relay=1;
 unsigned int DEF_from_level_check=1;
 unsigned int DEF_rcpt_level_check=0;
 unsigned int DEF_lavg_queue=20;
 unsigned int DEF_lavg_negative=40;
 unsigned int DEF_tarpit_sleep=60;
 unsigned int DEF_tarpit_limit=0xFFFFFFFF;
 unsigned int DEF_tls_enable=0;
 unsigned int DEF_tls_delivery=0;
 unsigned int DEF_force_alias_seek=0;
 unsigned int DEF_seek_df_alias=1;
 unsigned int DEF_srs_shift=0;
 unsigned int DEF_srs_alias_redir=1;
 unsigned int DEF_max_msgs_per_cnx=MAX_msgs_per_cnx;
 char nome_op[NUM_opcoes][24]={"Server_name\0",
                               "Event.limit\0",
                               "Event.connection\0",
                               "Event.helo\0",
                               "Event.rcpt\0",
                               "Event.from\0",
                               "Event.data\0",
                               "User\0",
                               "Group\0",
                               "Cp_errors_path\0",
                               "Temp_path\0",
                               "Queue_path\0",
                               "Report_file\0",
                               "Pid_file\0",
                               "Central_log\0",
                               "Sumary_log\0",
                               "Warning_log\0",
                               "Module\0",
                               "Dlocal\0",
                               "Adlocal_allowed\0",
                               "Msg_welcome\0",
                               "Msg_full_mailbox\0",
                               "Msg_invalid_cmd\0",
                               "Msg_invalid_param\0",
                               "Msg_sequence_error\0",
                               "Msg_no_mailbox\0",
                               "Msg_toomany_rcpts\0",
                               "Msg_relay_denied\0",
                               "Msg_transaction_falied\0",
                               "Msg_ok\0",
                               "Msg_send_body\0",
                               "Msg_allowed_sender\0",
                               "Msg_refused\0",
                               "Msg_allowed_rcpt\0",
                               "Msg_mail_accepted\0",
                               "Msg_goodbye\0",
                               "Msg_auth_ok\0",
                               "Msg_auth_falied\0",
                               "Msg_auth_required\0",
                               "Msg_nodisk_space\0",
                               "Msg_perm_deny\0",
                               "Msg_invalid_domain\0",
                               "Msg_header_toobig\0",
                               "Msg_internal_error\0",
                               "Msg_cannot_connect\0",
                               "Msg_mailbox_unavaibble\0",
                               "Msg_mail_toobig\0",
                               "Msg_lavg\0",
                               "Postmaster\0",
                               "Subject_error_msg\0",
                               "Report_from\0",
                               "Msg_cannot_resolve\0",
                               "Timezone\0",
                               "Sid\0",
                               "Log_lvl\0",
                               "Port\0",
                               "Max_rcpts\0",
                               "Max_mail_size\0",
                               "Max_attempts\0",
                               "Max_header_size\0",
                               "Max_error_report\0",
                               "Max_qprocs\0",
                               "Qlimit_max_procs\0",
                               "Qlimit_time\0",
                               "Qsleep_time\0",
                               "Connect_timeout\0",
                               "Mx_alias_ip\0",
                               "Cp_errors\0",
                               "Resolve_all\0",
                               "Hshow_user\0",
                               "Proto_level_check\0",
                               "Incorrect_pass_delay\0",
                               "Auth_tolerance\0",
                               "Limit_buf\0",
                               "Limit_cnx\0",
                               "Limit_time\0",
                               "Immed_delivery\0",
                               "Timeout\0",
                               "Queue_time\0",
                               "No_mailbox_delay\0",
                               "Auth_relay\0",
                               "From_level_check\0",
                               "Rcpt_level_check\0",
                               "Lavg_queue\0",
                               "Lavg_negative\0",
                               "Tarpit_sleep\0",
                               "Tarpit_limit\0",
                               "Tls_module\0",
                               "Tls_cafile",
                               "Tls_pubkey",
                               "Tls_privkey",
                               "Tls_enable",
                               "Tls_delivery",
                               "Refused_log",
                               "Event.qend_process",
                               "Force_alias_seek",
                               "Modseq_auth",
                               "Modseq_domain",
                               "Modseq_mail",
                               "Modseq_alias",
                               "Seek_df_alias",
                               "Srs_key",
                               "Srs_shift",
                               "Srs_alias_redir",
                               "Event.error_report",
                               "Max_msgs_per_cnx",
							   "Event.dl_rcpt",
							   "Event.lrcpt_refused",
							   "Df_domain"
							   };
void *ptr_op[NUM_opcoes]={     DEF_server_name,
                               DEF_event_limit,
                               DEF_event_connection,
                               DEF_event_helo,
                               DEF_event_rcpt,
                               DEF_event_from,
                               DEF_event_data,
                               DEF_user,
                               DEF_group,
                               DEF_cp_errors_path,
                               DEF_temp_path,
                               DEF_queue_path,
                               DEF_report_file,
                               DEF_pid_file,
                               DEF_central_log,
                               DEF_sumary_log,
                               DEF_warning_log,
                               DEF_module,
                               DEF_dlocal,
                               DEF_adlocal_allowed,
                               DEF_welcome_msg,
                               DEF_msg_full_mailbox,
                               DEF_msg_invalid_cmd,
                               DEF_msg_invalid_param,
                               DEF_msg_sequence_error,
                               DEF_msg_no_mailbox,
                               DEF_msg_toomany_rcpts,
                               DEF_msg_relay_denied,
                               DEF_msg_transaction_falied,
                               DEF_msg_ok,
                               DEF_msg_send_body,
                               DEF_msg_allowed_sender,
                               DEF_msg_refused,
                               DEF_msg_allowed_rcpt,
                               DEF_msg_mail_accepted,
                               DEF_msg_goodbye,
                               DEF_msg_auth_ok,
                               DEF_msg_auth_falied,
                               DEF_msg_auth_required,
                               DEF_msg_nodisk_space,
                               DEF_msg_perm_deny,
                               DEF_msg_invalid_domain,
                               DEF_msg_header_toobig,
                               DEF_msg_internal_error,
                               DEF_msg_cannot_connect,
                               DEF_msg_mailbox_unavaibble,
                               DEF_msg_mail_toobig,
                               DEF_msg_lavg,
                               DEF_postmaster,
                               DEF_subject_error_msg,
                               DEF_report_from,
                               DEF_msg_cannot_resolve,
                               DEF_timezone,
                               DEF_sid,
                               &DEF_log_lvl,
                               &DEF_port,
                               &DEF_max_rcpts,
                               &DEF_max_mail_size,
                               &DEF_max_attempts,
                               &DEF_max_header_size,
                               &DEF_max_error_report,
                               &DEF_max_qprocs,
                               &DEF_qlimit_max_procs,
                               &DEF_qlimit_time,
                               &DEF_qsleep_time,
                               &DEF_connect_timeout,
                               &DEF_mx_alias_ip,
                               &DEF_cp_errors,
                               &DEF_resolve_all,
                               &DEF_hshow_user,
                               &DEF_proto_level_check,
                               &DEF_incorrect_pass_delay,
                               &DEF_auth_tolerance,
                               &DEF_limit_buf,
                               &DEF_limit_cnx,
                               &DEF_limit_time,
                               &DEF_immed_delivery,
                               &DEF_timeout,
                               &DEF_queue_time,
                               &DEF_no_mailbox_delay,
                               &DEF_auth_relay,
                               &DEF_from_level_check,
                               &DEF_rcpt_level_check,
                               &DEF_lavg_queue,
                               &DEF_lavg_negative,
                               &DEF_tarpit_sleep,
                               &DEF_tarpit_limit,
                               DEF_tls_module,
                               DEF_tls_cafile,
                               DEF_tls_pubkey,
                               DEF_tls_privkey,
                               &DEF_tls_enable,
                               &DEF_tls_delivery,
                               DEF_refused_log,
                               DEF_event_qend_process,
                               &DEF_force_alias_seek,
                               DEF_modseq_auth,
                               DEF_modseq_domain,
                               DEF_modseq_mail,
                               DEF_modseq_alias,
                               &DEF_seek_df_alias,
                               DEF_srs_key,
                               &DEF_srs_shift,
                               &DEF_srs_alias_redir,
                               DEF_event_error_report,
                               &DEF_max_msgs_per_cnx,
							   DEF_event_dl_rcpt,
							   DEF_event_lrcpt_refused,
							   DEF_df_domain
							   };
 char def_ops_val[NUM_opcoes]={OP_DEF_ON,             // DEF_server_name
                               OP_DEF_OFF,            // DEF_event_limit
                               OP_DEF_OFF,            // DEF_event_connection
                               OP_DEF_OFF,            // DEF_event_helo
                               OP_DEF_OFF,            // DEF_event_rcpt
                               OP_DEF_OFF,            // DEF_event_from
                               OP_DEF_OFF,            // DEF_event_data
                               OP_DEF_OFF,            // DEF_user
                               OP_DEF_OFF,            // DEF_group
                               OP_DEF_ON,             // DEF_cp_errors_path
                               OP_DEF_OFF,            // DEF_temp_path
                               OP_DEF_OFF,            // DEF_queue_path
                               OP_DEF_ON,             // DEF_report_file
                               OP_DEF_OFF,            // DEF_pid_file
                               OP_DEF_ON,             // DEF_central_log
                               OP_DEF_ON,             // DEF_sumary_log
                               OP_DEF_ON,             // DEF_warning_log
                               OP_DEF_OFF,            // DEF_module
                               OP_DEF_ON,             // DEF_dlocal
                               OP_DEF_ON,             // DEF_adlocal_allowed
                               OP_DEF_OFF,            // DEF_welcome_msg
                               OP_DEF_ON,             // DEF_msg_full_mailbox
                               OP_DEF_OFF,            // DEF_msg_invalid_cmd
                               OP_DEF_OFF,            // DEF_msg_invalid_param
                               OP_DEF_OFF,            // DEF_msg_sequence_error
                               OP_DEF_ON,             // DEF_msg_no_mailbox
                               OP_DEF_OFF,            // DEF_msg_toomany_rcpts
                               OP_DEF_OFF,            // DEF_msg_relay_denied
                               OP_DEF_ON,             // DEF_msg_transaction_falied
                               OP_DEF_OFF,            // DEF_msg_ok
                               OP_DEF_OFF,            // DEF_msg_send_body
                               OP_DEF_OFF,            // DEF_msg_allowed_sender
                               OP_DEF_ON,             // DEF_msg_refused
                               OP_DEF_OFF,            // DEF_msg_allowed_rcpt
                               OP_DEF_OFF,            // DEF_msg_mail_accepted
                               OP_DEF_OFF,            // DEF_msg_goodbye
                               OP_DEF_OFF,            // DEF_msg_auth_ok
                               OP_DEF_OFF,            // DEF_msg_auth_falied
                               OP_DEF_OFF,            // DEF_msg_auth_required
                               OP_DEF_ON,             // DEF_msg_nodisk_space
                               OP_DEF_ON,             // DEF_msg_perm_deny
                               OP_DEF_ON,             // DEF_msg_invalid_domain
                               OP_DEF_ON,             // DEF_msg_header_toobig
                               OP_DEF_ON,             // DEF_msg_internal_error
                               OP_DEF_ON,             // DEF_msg_cannot_connect
                               OP_DEF_ON,             // DEF_msg_mailbox_unavaibble
                               OP_DEF_ON,             // DEF_msg_mail_toobig
                               OP_DEF_ON,             // DEF_msg_lavg
                               OP_DEF_ON,             // DEF_postmaster
                               OP_DEF_ON,             // DEF_subject_error_msg
                               OP_DEF_ON,             // DEF_report_from
                               OP_DEF_ON,             // DEF_msg_cannot_resolve
                               OP_DEF_ON,             // DEF_timezone
                               OP_DEF_ON,             // DEF_sid
                               OP_DEF_ON | OP_INT,    // DEF_log_lvl
                               OP_DEF_OFF | OP_INT,   // DEF_port
                               OP_DEF_ON | OP_INT,    // DEF_max_rcpts
                               OP_DEF_OFF | OP_INT,   // DEF_max_mail_size
                               OP_DEF_ON | OP_INT,    // DEF_max_attempts
                               OP_DEF_OFF | OP_INT,   // DEF_max_header_size
                               OP_DEF_ON | OP_INT,    // DEF_max_error_report
                               OP_DEF_OFF | OP_INT,   // DEF_max_qprocs
                               OP_DEF_OFF | OP_INT,   // DEF_qlimit_max_procs
                               OP_DEF_OFF | OP_INT,   // DEF_qlimit_time
                               OP_DEF_OFF | OP_INT,   // DEF_qsleep_time
                               OP_DEF_ON | OP_INT,    // DEF_connect_timeout
                               OP_DEF_ON | OP_INT,    // DEF_mx_alias_ip
                               OP_DEF_ON | OP_INT,    // DEF_cp_errors
                               OP_DEF_OFF | OP_INT,   // DEF_resolve_all
                               OP_DEF_OFF | OP_INT,   // DEF_hshow_user
                               OP_DEF_OFF | OP_INT,   // DEF_proto_level_check
                               OP_DEF_OFF | OP_INT,   // DEF_incorrect_pass_delay
                               OP_DEF_OFF | OP_INT,   // DEF_auth_tolerance
                               OP_DEF_OFF | OP_INT,   // DEF_limit_buf
                               OP_DEF_OFF | OP_INT,   // DEF_limit_cnx
                               OP_DEF_OFF | OP_INT,   // DEF_limit_time
                               OP_DEF_OFF | OP_INT,   // DEF_immed_delivery
                               OP_DEF_ON | OP_INT,    // DEF_timeout
                               OP_DEF_OFF | OP_INT,   // DEF_queue_time
                               OP_DEF_OFF | OP_INT,   // DEF_no_mailbox_delay
                               OP_DEF_OFF | OP_INT,   // DEF_auth_relay
                               OP_DEF_OFF | OP_INT,   // DEF_from_level_check
                               OP_DEF_OFF | OP_INT,   // DEF_rcpt_level_check
                               OP_DEF_ON | OP_INT,    // DEF_lavg_queue
                               OP_DEF_ON | OP_INT,    // DEF_lavg_negative
                               OP_DEF_ON | OP_INT,    // DEF_tarpit_sleep
                               OP_DEF_ON | OP_INT,    // DEF_tarpit_limit
                               OP_DEF_OFF,            // DEF_tls_module
                               OP_DEF_OFF,            // DEF_tls_cafile
                               OP_DEF_OFF,            // DEF_tls_pubkey
                               OP_DEF_OFF,            // DEF_tls_privkey
                               OP_DEF_ON,             // DEF_tls_enable
                               OP_DEF_ON,             // DEF_tls_delivery
                               OP_DEF_ON,             // DEF_refused_log
                               OP_DEF_ON,             // DEF_qend_process
                               OP_DEF_ON | OP_INT,    // DEF_force_alias_seek
                               OP_DEF_ON,             // DEF_modseq_auth
                               OP_DEF_ON,             // DEF_modseq_domain
                               OP_DEF_ON,             // DEF_modseq_mail
                               OP_DEF_ON,             // DEF_modseq_alias
                               OP_DEF_OFF | OP_INT,   // DEF_seek_df_alias
                               OP_DEF_ON,             // DEF_srs_key
                               OP_DEF_ON | OP_INT,    // DEF_srs_shift  
                               OP_DEF_ON | OP_INT,    // DEF_srs_alias_redir
                               OP_DEF_ON,             // DEF_event_error_report
                               OP_DEF_ON | OP_INT,    // DEF_max_msgs_per_cnx
							   OP_DEF_ON,             // DEF_event_dl_rcpt
							   OP_DEF_OFF,            // DEF_event_lrcpt_refused
							   OP_DEF_ON			  // DEF_df_domain
                               };
 int def_ops[NUM_opcoes];
 int num_ops=0;
 // -----------------------------------------------------
 char *smtp_resps[NUM_smtp_resps]={DEF_msg_invalid_cmd, DEF_msg_invalid_param, DEF_msg_sequence_error, DEF_msg_no_mailbox,
                                   DEF_msg_relay_denied, DEF_msg_transaction_falied, DEF_msg_ok, DEF_msg_resp_ehlo,
                                   DEF_msg_send_body, DEF_server_name, DEF_msg_allowed_sender, DEF_msg_allowed_rcpt,
                                   DEF_welcome_msg, DEF_msg_goodbye, DEF_msg_auth_ok, DEF_msg_auth_falied,
                                   DEF_msg_toomany_rcpts, DEF_msg_auth_required, DEF_msg_auth_login_u, DEF_msg_auth_login_p,
                                   DEF_msg_nodisk_space, DEF_msg_perm_deny, DEF_msg_invalid_domain, DEF_msg_header_toobig,
                                   DEF_msg_full_mailbox, DEF_msg_internal_error, DEF_msg_mail_toobig, DEF_msg_lavg,
                                   DEF_msg_refused, DEF_msg_mail_accepted};
 // -----------------------------------------------------
 time_t tempo;
 struct tm *timeinfo;
 struct str_tempo{
  char dia_semana[3];
  char fim1;
  char mes[3];
  char fim2;
  char dia[2];
  char fim3;
  char hora[2];
  char fim4;
  char minuto[2];
  char fim5;
  char segundo[2];
  char fim6;
  char ano[4];
  char fim7;
 }tlog;
 struct host_remoto{
  char ip[16];
  char nome[NS_MAXDNAME];
  char helo[TAM_helo + 1];
  char autenticado;
  char rbl;
  unsigned int ipn;
  unsigned char strlen_ip;
  unsigned int strlen_nome;
  unsigned int strlen_helo;
 }host;
 struct dados_email{
  char status;
  char email[TAM_endereco];
  char *dominio;
  char local;         // 0 = Dominio externo, 1 = Dominio local, -1 = Nao checado
  char resp[TAM_email_resp];
  char dest[TAM_email_dest];
  char auth[TAM_email_auth];
  int so_mark;
  char mx_source[NS_MAXDNAME];
  char *pass;
 }localhost, from, tmp_email, from_tmp, srs_tmp, *to=NULL, *atual_rcpt, *tmp_rcpt;
 struct struct_global_info{
  char ae;            // Aviso de entrega
 }global_info;
 struct str_mail_info{
  char user[TAM_endereco];
  char home[TAM_home];
 }auth_info, from_info, rcpt_info;
 struct str_mx_map{
  char ip[16];
  char auth[TAM_email_auth];
  unsigned int ipn;
  unsigned short porta;
  unsigned int so_mark;
  char mx_source[NS_MAXDNAME];
  int ini;
  int ult;
  char forcado;
  char finalizado;
 }*mx_map;
 struct str_mod_names{
  char mod_id[TAM_mod_name+1];
  int mod_index;
 }mod_names[MAX_modules];
 uid_t uid;
 gid_t gid;
 pid_t ppid;
 struct passwd *pwd;
 struct group *grp;
 // -- Variaveis de SOCKET --
 socklen_t tam_socket=sizeof(struct sockaddr_in);
 struct sockaddr_in rede_remota;
 int socket_remoto;
 struct timeval tval;
 // -- VARIAVEIS GLOBAIS de REGRAS --
 char R_CLOSE=0;
 char R_ACCEPT=0;        //BITS: 76543210 -> 0 = Force Accept | 1 = Auth Accept | 2 = Relay Accept
 char R_DENY=0;
 char R_RELAY=0;
 char R_REPLY[TAM_defs];
 char R_DATA_REPLY[TAM_defs];
 char R_HADD[TAM_defs];
 char R_EXEC_STR[TAM_exec_str];
 char R_RBL_TXT[NS_MAXDNAME + 1];
 char R_SERVER_RESP[NS_MAXDNAME + 1];
 char R_DSPOOL[TAM_defs];
 char R_MARK[TAM_mark];
 int R_TAM_HADD=0;
 int R_SPF=0;
 int R_HITS=0;
 int R_EXEC=0;
 int R_SO_MARK=0;
 // --
 void *modulo[MAX_modules];
 void *tls_mod;
 char mod_id[200];
 char mod_version[200];
 char etapa_smtp=ETAPA_helo;
 char tls_ativo=0;
 char cam_filac[200];
 char cam_filal[200];
 char fpid[10];
 char id_pid[TAM_id_fila];
 char id_fila[TAM_id_fila + 1];
 char tam_id_fila=0;
 char smtp_cmd[TAM_smtp_cmd + 1];
 char buffer[TAM_buffer + 1];
 char linha[TAM_buffer + 1];
 char hostname[200];
 char adomain[TAM_dominio];
 char *mod_user_info[MOD_user_ncampos];    //Ponteiros temporarios com as informacoes extras dos usuarios
       // 0 = user           
       // 1 = password       
       // 2 = home directory 
       // 3 = dlocal         
 char buffer_log_completo[TAM_buffer_log + 23];
 char *buffer_log=&buffer_log_completo[22];    // Apontando para ficar a frente da data
 char *buffer_log_juncao=&buffer_log_completo[21];
 char auth_user[TAM_endereco];
 char auth_pass[TAM_endereco];
 char ult_dom_int[NS_MAXDNAME];
 char ult_dom_ext[NS_MAXDNAME];
 char log_strtempo[30];
 char log_resumo_tipo[3];
 char log_resumo_size[11];
 char temp=0;
 char ret_val=0;
 char srs_from[TAM_endereco];
 char srs_rcpt[TAM_endereco];
 char rem_arq_signal=0;
 char ret_alias[MAX_buffer_alias][TAM_endereco];
 char wait_log=0;
 float etapa_global=0;
 double load_avg=0;
 int arq_log;
 int modseq_auth[MAX_modules+1];
 int modseq_domain[MAX_modules+1];
 int modseq_mail[MAX_modules+1];
 int modseq_alias[MAX_modules+1];
 int num_mods=0;
 int *mx_index;
 int num_smtp_resp=0;
 unsigned int msg_cont=0;
 unsigned int tam_email=0;
 unsigned int num_rcpt=0;
 unsigned int num_rcpts=0;
 unsigned int prox_num_rcpt=0;
 unsigned int tam_mem_rcpts=0;
 unsigned int ips_locais[MAX_ips_locais];
 unsigned int tam_header;
#endif




